<%@ Page Language="VB" AutoEventWireup="false" CodeFile="ClientCalendarVB.aspx.vb"
    Inherits="ClientCalendarVB" %>

<%@ Register TagPrefix="radcln" Namespace="Telerik.WebControls" Assembly="RadCalendar.Net2" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
        <div>

            <script type="text/javascript">
            var DayOfWeek = {
                                Monday: 1,
                                Tuesday: 2,
                                Wednesday: 3,
                                Thursday: 4,
                                Friday: 5,
                                Saturday: 6,
                                Sunday: 0
                             };
            
            function OnDayRender(sender, args)
            {
                var monthStartDate = sender.CurrentViews[0]._MonthStartDate;
                var monthEndDate = sender.CurrentViews[0]._MonthEndDate;
                var jsDate = new Date(args.Date[0], (args.Date[1] - 1), args.Date[2]);
                
                // culture-specific: you will need to modify this condition if the FirstDayOfWeek for your calendar is not Sunday
                var isFirstDayOfWeek = (jsDate.getDay() == DayOfWeek.Sunday);
                
                jsDate.setDate(jsDate.getDate() + 7);
                var date = [jsDate.getFullYear(), (jsDate.getMonth() + 1), jsDate.getDate()];

                if (isFirstDayOfWeek && (CompareDates(date, monthStartDate) == 0 || CompareDates(args.Date, monthEndDate) > 0))
                {
                    args.Cell.parentNode.style.display = "none";
                }    
            }
            
            function OnCalendarViewChanging(sender, step)
            {
                // do not reset the row visibility if the new view would be out of the valid range for radCalendar
                // i.e. the calendar would remain on the current view so we need the row visibility as it is (OnDayRender will not be executed) 
                var minDate = sender.GetRangeMinDate();
                var jsDate = new Date(minDate[0], (minDate[1] - 1), minDate[2] + 1);
                var firstValidDate = [jsDate.getFullYear(), (jsDate.getMonth() + 1), jsDate.getDate()];
                
                var maxDate = sender.GetRangeMaxDate();
                var monthStartDate = sender.CurrentViews[0]._MonthStartDate;
                var monthEndDate = sender.CurrentViews[0]._MonthEndDate;

                if ((step > 0 && CompareDates(maxDate, monthEndDate) <= 0) || (step < 0 && CompareDates(monthStartDate, firstValidDate) <= 0))
                {
                    return false;
                }
                
                // reset the row visibility i.e. make them all visible prior to the execution of the OnDayRender handler
                var tableId = sender.ClientID + "_Top";
                var rows = document.getElementById(tableId).getElementsByTagName("tr");
                for (var i=0; i < rows.length; i++)
                {
                    rows[i].style.display = "";
                }
            }
            
            function CompareDates(date1, date2)
            {
	            if (!date1 || date1.length != 3)
		            throw new Error("Date1 must be array: [y, m, d]");
            		
	            if (!date2 || date2.length != 3)
		            throw new Error("Date2 must be array: [y, m, d]");

	            var y1 = date1[0];
	            var y2 = date2[0];	
            	
	            if (y1 < y2) 
		            return -1;
	            if (y1 > y2) 
		            return 1;
            	
	            var m1 = date1[1];
	            var m2 = date2[1];	
            	
	            if (m1 < m2) 
		            return -1;
	            if (m1 > m2) 
		            return 1;
            	
	            var d1 = date1[2];
	            var d2 = date2[2];
            	
	            if (d1 < d2) 
		            return -1;		
	            if (d1 > d2) 
		            return 1;
            	
	            return 0;
            };
            </script>

            <radcln:RadCalendar ID="RadCalendar1" runat="server" ShowOtherMonthsDays="false"
                OnDayRender="RadCalendar1_DayRender">
                <ClientEvents OnDayRender="OnDayRender" OnCalendarViewChanging="OnCalendarViewChanging" />
            </radcln:RadCalendar>
        </div>
    </form>
</body>
</html>
